% demo of OLHash.m

X = rand(512,1000);
num_anchor = 300;
idx_tmp = randperm(1000,1000);
idx_anchor = idx_tmp(1:300);
idx_train = idx_tmp(301:end);
label = randint(450,1); % generate fake label
clear idx_tmp

% % if kernel trick is applied
% anchor = X(:,idx_anchor);
% K = sqdist(X,anchor);
% X = exp(-K');

para.alpha = 0; % other options: 1 or 2
para.beta = 0.3; % other options: 0.4, 0.5. (between 0 and 1)
para.c = 0.1;
para.T = 1; % num of models. T = 1: single model; T > 1 multiple models
para.r = 32;
model(1).W = rand(size(X,1),para.r)-0.5;

x_avg = mean(X(:,idx_anchor),2);


for i = 1:floor(length(idx_train)/2)
    x1 = X(:,idx_train(2*i-1));
    x2 = X(:,idx_train(2*i));
    x_avg =  (x_avg*(num_anchor+i*2-2)+sum([x1 x2],2))/(num_anchor+i*2); % update the data center
    y = label(i); % obtain the similarity label betweeb x1 and x2
    model = OLHash(x1-x_avg,x2-x_avg,y,model,para);
%     model_list(i).model = model; % record all models for testing
end
    
    